#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <string.h>
#define NCHAR 20
enum {
  alanine = 0, arginine, asparagine, aspartic, cysteine, 
  glutamine, glutamic, glycine, histidine, isoleucine,
  leucine, lysine, methionine, phenylalanine, proline,
  serine, threonine, tryptophan, tyrosine, valine
};
#define InverseCDFGamma(prob,alpha,beta) InverseCDFChi2(prob,2.0*(alpha))/(2.0*(beta))
#define SIGN(a,b) ((b) >= 0.0 ? fabs(a) : -fabs(a))
#ifndef PI
   #define PI 3.14159265358979323846
#endif
FILE *fopene(char *filename, char *rw, char *err);
char get_param(int *k, char **arg, char *value);
void get_params(int n, char **arg, FILE **binfile, FILE **ibinfile, 
		int *iseed, int *nrand, int *nbinl, int *nbinu);
void binrandf(int nbin, int *bin);
int l2ip(char c);
void rmgap(int numsp, int *nsite, char *seqc);
int rinterleave_block(FILE *infile, int numsp, int nsite, char name[][11], 
		       char *seq, int *initb);
char ignore_whitespace_seqfile(FILE *infile);
void rinterleavef_nolim(FILE *infile, const int *numsp, const int *nsite, 
			char name[][11], char *seq);
void letter(int numsp, int nsite, char *seq);
int rseqf(FILE *fp, char *seq);
void pchar_freq(int nchar, int nsite, int *s1, int *s2, double *pf);
void char_freq(int nchar, int numsp, int nsite, int *seq, double *freq);
int pair_Fmat(int nsite, int nbin, int *s1, int *s2, double *Fxy, double *Pi);
int log_piFxy(int nbin, double *Fxy, double *Pi, double *q);
double gtr_dist(int nbin, double *q, double *Pi);
double gtrpair_Qdist(int nsite, int nbin, int *s1, int *s2, double *q);
int gtrpair_Qdists(int numsp, int nsite, int nbin, int nel, int *sb, double *d, 
		   double *q);
double ls_q(int nel, double *q1, double *q2);
double ls_gtr(int numsp, int nsite, int nbin, int *sb, double *dmat);
int nel_bin(int binl, int *bin);
void bin_rearrangement(int nbin, int *bin, int *elp, int *bap, int *newbin);
void s2binm(int numsp, int nsite, int *seq, int *bin, int *seqb);
double min_eig_pair_gtr(int nsite, int nbin, int *s1, int *s2);
double min_eig_gtr(int numsp, int nsite, int nbin, int *s);
double maxmin_eig_gtr(int numsp, int nsite, int nbin, int *seq, int *bin, int *seqb);
double best_bin_gtr(int numsp, int nsite, int nbin, int *seq, int *bin, 
		    double *dmat);
int num_bin(int nbin, int *bin);
void opt_q(int numsp, int nsite, int nbin, int *seq, int *bin, double *q);
 double  best_bin_gtr_rand(int numsp, int nsite, int nbin, int nrand, int *seq, 
			   int *bin, double *dmat);
void get_nsitev(int numsp, int nsite, int *seq, int *nsitev);
void create_fmat(int ntaxa, int nsite, int *seq, double *fmat, double *fr);
void create_pfarray(int ntaxa, int nsite, int *seq, double *pfa);
void create_pfarray_bin(int nbin, int *bin, double *pf, double *pf_bin);
double chisq_crit(int ntaxa, int *nsitev, int nbin, int *bin, double *fmat, 
		  double *fr, double *pfa);
double chisq_max_crit(int ntaxa, int *nsitev, int nbin, int *bin, double *fmat, 
		      double *fr, double *pfa);
void prfmat(int ntaxa, int nbin, int *bin, double *fmat, double *fr);
double percent_crit(int ntaxa, int *nsitev, int nbin, int *bin, double *fmat, 
		    double *fr, double *pfa);
double entropy_crit(int ntaxa, int *nsitev, int nbin, int *bin, double *fmat, 
		    double *fr, double *pfa);
double entropy_ave_crit(int ntaxa, int *nsitev, int nbin, int *bin, 
			double *fmat, double *fr, double *pfa);
double match_crit_pair(int nbin, int *bin, double *pf);
double match_crit(int ntaxa, int *nsitev, int nbin, int *bin, double *fmat, 
		  double *fr, double *pfa);
double bowker_crit_pair(int nbin, int *bin, double *pf);
double bowker_crit(int ntaxa, int *nsitev, int nbin, int *bin, double *fmat, 
		   double *fr, double *pfa);
double best_bin_chisq(int ntaxa, int *nsitev, int nbin, int *bin, double *fmat, 
		      double *fr, double *pfa, int crit_id);
int eigenRealSym(double A[], int n, double Root[], double Offdiag[]);
void EigenSort(double d[], double U[], int n);
void HouseholderRealSym(double a[], int n, double d[], double e[]);
int EigenTridagQLImplicit(double d[], double e[], int n, double z[]);
double pchisq(double x, int df);
void sample(int n, int m, int *isamp);
double *cvec(int n);
int *civec(int n);
int chol(int m, double *l);
void cholh(int m, double *l, double *b);
double pnorm(double x, double a, double b);
double urand(void);
double dot(int n, double *u, int incu, double *v, int incv);
